<template>
    <div class="relative board bg-white mr-2 p-2 float-left w-full flex flex-col text-gray-600">
        <div class="heading font-bold text-gray-800 bg-gray-100 h-8 border-b -mt-2 -ml-2 -mr-2 rounded-t-lg pl-2 pt-1">
            <div class="title relative float-left text-purple-500">
                <div class="h-4 w-4 m-auto cursor-pointer inline-block">
                    <img svg-inline class="fill-current inline-block" src="./pix/zond/plugin.svg" />
                </div>
                <span>
                    Import a Spreadsheet
                </span>
            </div>
            <div class="submit relative float-right">
                <button class="text-purple-500 hover:text-purple-700 text-purple-800 font-bold py-1 px-2 text-sm rounded inline-flex items-center" v-on:click="upload()">
                    <img svg-inline class="fill-current inline-block w-4 h-4 mr-2" src="./pix/zond/add-solid.svg" />
                    <span>Import</span>
                </button>
                <button class="text-red-500 hover:text-red-700 text-gray-800 font-bold py-1 px-2 text-sm rounded inline-flex items-center" v-on:click="discard()">
                    <img svg-inline class="fill-current inline-block w-4 h-4 mr-2" src="./pix/zond/close-solid.svg" />
                    <span>Cancel</span>
                </button>
            </div>
        </div>
        <div class="form w-full h-full">
            <div class="body flex flex-row items-stretch content-center w-full h-full">
                <div class="meta flex flex-col mt-2 float-left mr-1 flex-grow">
                    <div class="input flex flex-col items-left mb-1 bg-purple-200 py-1 px-2 text-sm">
                        <label class="mb-1 text-purple-700 font-semibold">Area</label>
                        <input type="text" v-model="colAoI" value="" class="w-full bg-purple-100 h-8 border border-purple-400 rounded-md px-2" />
                    </div>
                    <div class="input flex flex-col items-left mb-1 bg-gray-200 py-1 px-2 text-sm">
                        <label class="mb-1 text-gray-700 font-semibold">Type of Report</label>
                        <v-select v-model="reportType" label="label" :options="types" :reduce="type => type.id" class="w-full bg-gray-100"></v-select>
                    </div>
                    <div class="input flex flex-col items-left mb-1 bg-gray-200 py-1 px-2 text-sm">
                        <label class="mb-1 text-gray-700 font-semibold">Time of Interest (ToI)</label>
                        <v-date-picker mode="single" v-model="reportToI" class="w-full relative" :popover="{visibility: 'click' }"></v-date-picker>
                    </div>
                </div>
                <div class="meta flex flex-col mt-2 ml-2 float-left border-l flex-grow">
                    <div class="input flex flex-col items-left mb-1 bg-blue-200 py-1 px-2 text-sm">
                        <label class="mb-1 text-blue-700 font-semibold">Excel Sheet</label>
                        <input type="file" id="file" ref="file" v-on:change="attach()"/>
                    </div>
                    <div class="input flex flex-col items-left mb-1 bg-gray-200 py-1 px-2 text-sm">
                        <label class="mb-1 text-gray-700 font-semibold">District</label>
                        <v-select v-model="reportDistrict" label="label" :options="districts" :reduce="district => district.value" class="w-full bg-gray-100"></v-select>
                    </div>
                    <div class="input flex flex-col items-left mb-1 bg-purple-200 py-1 px-2 text-sm">
                        <div class="label flex flex-row justify-end">
                            <label class="mb-1 text-purple-700 font-semibold flex-grow">Tags</label>
                            <button class="bg-purple-400 text-purple-800 hover:text-purple-700 font-bold py-1 px-2 text-xs rounded inline-flex items-center my-1" v-on:click="openTagger()">
                                <img svg-inline class="fill-current inline-block w-4 h-4 mr-2" src="./pix/zond/bolt.svg" />
                                <span>Add</span>
                            </button>
                        </div>
                        <div class="align-middle inline-block min-w-full shadow overflow-hidden">
                            <div class="w-full bg-purple-100 p-2 text-xs" v-if="reportTags.length == 0">
                                No Tags added
                            </div>
                            <table v-else class="min-w-full">
                                <tbody class="bg-white">
                                    <tr v-for="(tag, i) in reportTags" :key="i" class="border-b border-gray-200">
                                        <td class="px-1">{{tag.column}} </td>
                                        <td class="px-1">{{tag.name}}</td>
                                    </tr>
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div v-if="modal" class="absolute left-0 top-0 bg-white opacity-75 w-full h-full flex flex-col">
            <button class="text-pink-500 hover:text-pink-700 text-gray-800 font-bold py-1 px-2 text-sm rounded inline-flex items-center absolute right-0 top-0 mr-2 mt-2" v-on:click="resetModal()">
                <img svg-inline class="fill-current inline-block w-8 h-8" src="./pix/zond/close-outline.svg" />
            </button>
            <div v-if="message" class="w-full m-auto text-center">{{message}}</div>
            <div v-if="importing" class="w-full m-auto text-center">
                <img src="./pix/infinity.gif" class="block relative m-auto" />
                Importing Spreadsheet ... 
            </div>
            <div v-if="imported" class="w-full m-auto text-center">
                <img svg-inline class="fill-current w-32 h-32 block m-auto mb-2 text-pink-600" src="./pix/zond/thumbs-up.svg" />
                Import Completed
            </div>
            
            <div v-if="tagging" class="tag flex flex-col">
                <div class="flex flex-row">
                    <div class="meta flex flex-col mt-2 float-left mr-1 flex-grow">
                        <div class="input flex flex-col items-left mb-1 bg-purple-200 py-1 px-2 text-sm">
                            <label class="mb-1 text-purple-700 font-semibold">Column Number</label>
                            <input v-model="tagColumn" type="text" value="" class="w-full bg-purple-100 h-8 border border-purple-400 rounded-md px-2" />
                        </div>
                    </div>
                    <div class="meta flex flex-col mt-2 float-left mr-1 flex-grow">
                        <div class="input flex flex-col items-left mb-1 bg-purple-200 py-1 px-2 text-sm">
                            <label class="mb-1 text-purple-700 font-semibold">Column Name</label>
                            <input v-model="tagName" type="text" value="" class="w-full bg-purple-100 h-8 border border-purple-400 rounded-md px-2" />
                        </div>
                    </div>
                </div>
                <div class="input flex flex-row justify-end mb-1 py-1 px-2 text-sm mt-2">
                    <button class="bg-red-200 text-red-500 hover:text-red-700 text-gray-800 font-bold py-1 px-2 text-sm rounded inline-flex items-center mr-2" v-on:click="cancelTagging()">
                        <img svg-inline class="fill-current inline-block w-4 h-4 mr-2" src="./pix/zond/block.svg" />
                        <span>Cancel</span>
                    </button>
                    <button class="bg-purple-200 text-purple-500 hover:text-purple-700 text-purple-800 font-bold py-1 px-2 text-sm rounded inline-flex items-center" v-on:click="addTag()">
                        <img svg-inline class="fill-current inline-block w-4 h-4 mr-2" src="./pix/zond/bookmark.svg" />
                        <span>Add</span>
                    </button>
                </div>
            </div>
        </div>
    </div>
</template>
<script>
    import Vue from 'vue'
    import vSelect from 'vue-select'
    import axios from 'axios'
    import axiosCancel from 'axios-cancel';
    import VCalendar from 'v-calendar';
    var moment = require('moment');
    
    const DB_WB_DISTRICTS =  [{"value":"AD","label":"Alipurduar"},{"value":"BN","label":"Bankura"},{"value":"BR","label":"Paschim Bardhaman"},{"value":"BR","label":"Purba Bardhaman"},{"value":"BI","label":"Birbhum"},{"value":"KB","label":"Cooch Behar"},{"value":"DA","label":"Darjeeling"},{"value":"UD","label":"Uttar Dinajpur"},{"value":"DD","label":"Dakshin Dinajpur"},{"value":"HG","label":"Hooghly"},{"value":"HR","label":"Howrah"},{"value":"JP","label":"Jalpaiguri"},{"value":"JH","label":"Jhargram"},{"value":"KO","label":"Kolkata"},{"value":"KA","label":"Kalimpong"},{"value":"MA","label":"Malda"},{"value":"ME","label":"Paschim Medinipur"},{"value":"ME","label":"Purba Medinipur"},{"value":"MU","label":"Murshidabad"},{"value":"NA","label":"Nadia"},{"value":"PN","label":"North 24 Parganas"},{"value":"PS","label":"South 24 Parganas"},{"value":"PU","label":"Purulia"}];;
    
    Vue.component('v-select', vSelect);
    Vue.use(VCalendar);

    axiosCancel(axios, {
        debug: false // default
    });
    
    export default {
        name: "WeeSpatialReportImporter",
        props: {
            project: {
                type: Number,
                required: true
            },
            cancel: {
                type: Function,
                default: function(){}
            }
        },
        data(){
            return {
                districts: DB_WB_DISTRICTS,
                types: synopsis.types,
                file: '',
                reportTags: [],
                modal: false,
                tagging: false,
                reportToI: '',
                reportType: synopsis.types.length ? synopsis.types[0].id : '',
                colAoI: 0,
                modal:  false,
                importing: false,
                imported: false,
                message: null
            };
        },
        methods: {
            resetModal(){
                this.importing  = false;
                this.imported   = false;
                this.modal      = false;
            },
            discard(){
                this.cancel();
                this.cancelTagging();
            },
            attach(){
                this.file = this.$refs.file.files[0];
            },
            upload(){
                let self = this;
                this.resetModal();
                this.modal  = true;
                this.importing = true;
                let errorf = function(message){
                    self.importing = false;
                    self.message = message;
                    setTimeout(function(){
                        self.resetModal();
                    }, 1000);
                }
                
                const fixed_props = {
                    'district': this.reportDistrict
                };
                
                const toi = moment(this.reportToI).format("YYYY-MM-DD hh:mm:ss");
                console.log("toi", toi);
                let formData = new FormData();
                formData.append('aoi',    this.colAoI);
                formData.append('file',   this.file);
                formData.append('toi',    toi);
                formData.append('type',   this.reportType);
                formData.append('fixed',  JSON.stringify(fixed_props));
                formData.append('tags',   JSON.stringify(this.reportTags));
                console.log(formData.entries());
                axios.post(this.uploadUrl, formData, {
                    headers: {
                        'Content-Type': 'multipart/form-data'
                    }
                }).then(function(response){
                    if(response.data.success){
                        self.importing = false;
                        self.imported  = true;
                        setTimeout(function(){
                            self.resetModal();
                            self.$emit('imported');
                        }, 2000);
                    }else{
                        errorf(response.data.message);
                        // TODO Failed to save report
                    }
                }).catch(function(){
                    console.log('FAILURE!!');
                });
                
            },
            openTagger(){
                this.modal = true;
                this.tagging = true;
            },
            addTag(){
                this.reportTags.push({
                    column: this.tagColumn,
                    name:   this.tagName
                });
                this.modal = false;
                this.tagging = false;
                this.tagColumn = 0;
                this.tagName = '';
            },
            cancelTagging(){
                this.modal = false;
                this.tagging = false;
                this.tagColumn = 0;
                this.tagName = '';
            }
        },
        computed: {
            uploadUrl(){
                return this.project ? ('/reports/'+this.project+'/import') : null;
            }
        }
    }
</script>
<style scoped>
</style>
